<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Tetris</title>
<meta NAME="author" CONTENT="Sylvain MARECHAL">
<meta NAME="keywords" CONTENT="tetris">
<meta NAME="Revisit-after" CONTENT="15 days">
<link rel=stylesheet href="../../../style.css" type="text/css">
</head>
<body>
<body>
<?php phpversion()?>

<h1>Tetris</h1>
<h3>Introduction</h3>
<p>
Le tetris ci-dessous est un portage du 
<a href="../../../iris1/tetris/html/tetris.html">projet Tetris</a>
 que j'avais cr  l'poque pour former mes lves BTS IRIS au langage C.<br/>
 Les scores sont stocks sur le site dans un fichier 
 <tt><a href="tetrisscores.txt">tetriscores.txt</a></tt>. PHP est utilis afin
 de lire et crire les scores dans ce fichier. 
</p>

<h3>Sources (java et tetris.php)</h3>
<p>
<a href="tetrisjava.tar.gz">tetrisjava.tar.gz</a>
</p>


<hr/>
<applet code="TetrisApplet.class" archive="tetris.jar" width=600 height=510></applet>
<hr/>


<?php

/*! Parsing du fichier
 *
 * \param $file le nom du fichier
 * \param $tabScores [OUT] un tableau avec tous les scores
 */
function parseScore( $file, & $tabScores )
{

    // On lit le fichier ligne par ligne
    $handle = fopen( $file, 'rb' );
    if( ! empty($handle) )
    {
        while (!feof ($handle)) 
        {         
            $line = fgets($handle, 4096);
            parseScoreLine( $line, $tabScores );
        }
    }
    fclose ($handle);
    
    // On trie les scores
    if( ! empty($tabScores) )
    {
        arsort( $tabScores );
    }
}

/*! Parsing d'une ligne du fichier
 *
 * \param $file le nom du fichier
 * \param $tabScores [OUT] un tableau avec tous les scores
 */
function parseScoreLine( $line, & $tabScores )
{
    // On utilise une expression reg. pour parser chaque ligne
    $result = ereg(
            // Score
            '([[:digit:]]*)[[:space:]]' .
            // Nom
            '"(.*)"[[:space:]]' .
            // Adresse
            '(.*)[[:space:]]' .
            // Host
            '(.*)[[:space:]]' .
            // User Agent
            '"(.*)"[[:space:]]',
            $line, $res);

    $i = 0;
    // Score
    $score = $res[++$i];
    // Nom
    $nom = $res[++$i];
    // Adresse
    $addr = $res[++$i];
    // Host
    $host = $res[++$i];
    // User Agent
    $ua = $res[++$i];
    
    if( $score != 0 && ! empty($nom) )
    {
        $tabScores[] = array( $score, $nom, $addr, $host, $ua );
    }
}

/*! Ecrit une ligne ds le fichier
 *
 * \param $file le fichier
 * \param $score le score
 * \param $nom le nom
 * \param $addr l'adresse 
 * \param $host le host
 * \param $ua le ua
 * \return false si pb, sinon true
 */
function writeLine( $handle, $score, $nom, $addr, $host, $ua )
{
    // generation de la ligne : On separe le nom et le ua avec
    // des guillemets
    $content = $score . ' ' .
        '"' . $nom . '"' . ' ' .
        $addr . ' ' .  
        $host . ' ' .
        '"' . $ua . '"' . "\n";
    
    // Ecrivons dans notre fichier.
    if (fwrite($handle, $content) === FALSE) 
    {
        //echo "Impossible d'crire dans le fichier ($file)";
        return false;
    }
    return true;
}    

/*! Ajoute une ligne dans le fichier de score
 *
 * Le score n'est ajoute que s'il fait partie des 100 meilleurs
 * scores
 *
 * \param $file le fichier
 * \param $score le score
 * \param $nom le nom
 * \param $addr l'adresse 
 * \param $host le host
 * \param $ua le ua
 * \return false sii pb, sinon true
 */
function addScore( $file, $score, $nom, $addr, $host, $ua, & $tabScores )
{
    // Assurons nous que le fichier est accessible en criture
    if (is_writable($file)) 
    {
        // On va chercher les scores actuels
        parseScore( $file, $tabScores );
        
        // On ajoute le score
        $tabScores[] = array( $score, $nom, $addr, $host, $ua );
        
        // On retrie le tableau
        arsort( $tabScores );
        
        // On supprime les derniers elements tq len(tab) > 100
        while( count( $tabScores ) > 100 )
        {
            array_pop( $tabScores );
        }
        
        // On ouvre le fichier en effacant le contenu        
        if (!$handle = fopen($file, 'w')) 
        {
            //echo "Impossible d'ouvrir le fichier ($file)";
            return false;
        }
        
        // On ecrit les donnees
        foreach( $tabScores as $tabUnScore )
        {
            writeLine( $handle, $tabUnScore[0], $tabUnScore[1], 
                $tabUnScore[2], $tabUnScore[3], $tabUnScore[4] );
        }

        // On ferme et on quitte        
        fclose($handle);
        return true;
    }    
    //echo "Le fichier $file n'est pas accessible en criture.";
    return false;
}

?>




<?php
$file = 'tetrisscores.txt';

if( ! empty( $HTTP_GET_VARS ) )
{
    $nom = $HTTP_GET_VARS['nom'];
    $score = $HTTP_GET_VARS['score'];
    $addr = $HTTP_SERVER_VARS['REMOTE_ADDR'];
    $host = $HTTP_SERVER_VARS['REMOTE_HOST'];
    $ua = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];        
    
    addScore( $file, $score, $nom, $addr, $host, $ua, $tabScores );
}
else
{
    parseScore( $file, $tabScores );
}

?> 
<h3>Les meilleurs scores</h3>
<hr/>
<table>
<tr>
    <th>Nom</th>
    <th>Score</th>
    <th>Adresse</th>
    <th>UA</th>
</tr>
<?php if( !empty($tabScores) ) foreach( $tabScores as $tabUnScore ) { ?>
<tr>
<td align="center"><?php echo $tabUnScore[1] ?></td>
<td align="center"><?php echo $tabUnScore[0] ?></td>
<td align="center"><?php echo $tabUnScore[2] ?></td>
<td align="center"><?php echo $tabUnScore[4] ?></td>
<?php } ?>
</table>
<hr/>
<a href=javascript:location.reload()>Rafrachir</a>
</body>
</html>