/*
 * Created on 15 juin 2005
 *
 * 
 */
import java.awt.*;
import java.awt.event.*;

import tetris.ApplicationEvents;
import tetris.SaveScore;
import tetris.TetrisCore;
import tetris.TetrisEvents;
import tetris.TetrisGraphics;
import tetris.TetrisValeur;

/**
 * @author sylvain
 *
 */
public class TetrisMain /*extends Frame*/ 
	implements 	KeyListener, WindowListener, ActionListener, 
				Runnable,
				TetrisGraphics,
				TetrisEvents,
				ApplicationEvents
{
    private Container m_ctn = null;
    private boolean m_Jeu = false;
    private boolean m_Perdu = false;
    private boolean m_Pause = false;
    private TetrisCore m_TetrisCore = null;
    private TetrisPlay m_TetrisPlay = null;
    private TetrisInfos m_TetrisInfos = null;
    private Thread m_TetrisThread = null;
    private Button m_bJouer, m_bPause, m_bScores, m_bAPropos;
    private SaveScore m_saveScore = null;
    
    /**
     * @see java.lang.Runnable#run()
     */
    public void run() {
        while( true )
        {
            try 
            {
                int Delai = m_TetrisCore.getDelai();
                Thread.sleep( Delai );
                if( m_Pause == false)
                {
                    boolean ret = m_TetrisCore.Descend();
                    if( ret == false )
                    {
	                    m_Perdu = true;
	                    m_Jeu = false;
	                    onButtonAddScores();
	                    return;
                    }
                }
            }
            catch( InterruptedException e )
            {
                //
            }
        }

    }
    /**
     * @see java.awt.event.WindowListener#windowActivated(java.awt.event.WindowEvent)
     */
    public void windowActivated(WindowEvent arg0) {}
    /**
     * @see java.awt.event.WindowListener#windowDeactivated(java.awt.event.WindowEvent)
     */
    public void windowDeactivated(WindowEvent arg0) {}
    /**
     * @see java.awt.event.WindowListener#windowDeiconified(java.awt.event.WindowEvent)
     */
    public void windowDeiconified(WindowEvent arg0) {}
    /**
     * @see java.awt.event.WindowListener#windowIconified(java.awt.event.WindowEvent)
     */
    public void windowIconified(WindowEvent arg0) {}
    /**
     * @see java.awt.event.WindowListener#windowOpened(java.awt.event.WindowEvent)
     */
    public void windowOpened(WindowEvent arg0) {}
    /**
     * @see java.awt.event.WindowListener#windowClosed(java.awt.event.WindowEvent)
     */
    public void windowClosed(WindowEvent e) {
        System.exit(0);
    }
    /**
     * @see java.awt.event.WindowListener#windowClosing(java.awt.event.WindowEvent)
     */
    public void windowClosing(WindowEvent e) {
        e.getWindow().dispose();
    }

    /** Constructeur
     * @param ctn
     * @param saveScore
     * 
     */
    TetrisMain( Container ctn, SaveScore saveScore )
    {
        m_ctn = ctn;
        m_saveScore = saveScore;
        m_ctn.setSize (640, 480);
        m_ctn.setVisible (true);
        m_ctn.setBackground(Color.lightGray);
        
//        m_ctn.addWindowListener(this);
        m_ctn.addKeyListener(this);
        m_ctn.requestFocus();
        
        
        
        m_ctn.setLayout(new GridLayout(1,3));
        m_TetrisPlay = new TetrisPlay();
        m_TetrisInfos = new TetrisInfos();
        
        Panel pButtons = new Panel();
        pButtons.setLayout( new GridLayout(18,3));
        m_bJouer = new Button( "Jouer");
        m_bPause = new Button( "Pause");
        m_bScores = new Button( "Scores");
        m_bAPropos = new Button( "A propos");

        pButtons.add( m_bJouer );
        pButtons.add( m_bPause );
//        pButtons.add( m_bScores );
//        pButtons.add( m_bAPropos );
        pButtons.add( new Panel() );
        pButtons.add( new Label( "Tetris JAVA") );
        pButtons.add( new Label( "Sylvain MARECHAL") );
        pButtons.add( new Label( "06/2005") );
        m_ctn.add( pButtons );
        m_ctn.add( m_TetrisPlay );
        m_ctn.add( m_TetrisInfos );

        
        m_bJouer.addActionListener(this);
        m_bPause.addActionListener(this);
        m_bScores.addActionListener(this);
        m_bAPropos.addActionListener(this);
    }
    
    /**
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
     */
    public void actionPerformed(ActionEvent evt) {
        Object source = evt.getSource();
        if( source == m_bJouer )
        {
            onButtonPlay();
        }
        if( source == m_bPause )
        {
            onButtonPause();
        }        
        if( source == m_bScores )
        {    
            onButtonShowScores();
        }
        if( source == m_bAPropos )
        {    
            onButtonAPropos();
        }
        m_ctn.requestFocus();
    }
    
    /** Main
     * @param args
     */
    /*public static void main(String[] args) {
        Frame fm = new Frame(); 
        TetrisMain tetrisMain= new TetrisMain (fm, null);
        fm.addWindowListener(tetrisMain);
    }*/
    
    /**
     * @see java.awt.event.KeyListener#keyReleased(java.awt.event.KeyEvent)
     */
    public void keyReleased(KeyEvent evt) {}

    /**
     * @see java.awt.event.KeyListener#keyTyped(java.awt.event.KeyEvent)
     */
    public void keyTyped(KeyEvent evt) {}

    /**
     * @see java.awt.event.KeyListener#keyPressed(java.awt.event.KeyEvent)
     */
    public void keyPressed(KeyEvent evt)
    {  
        int t=evt.getKeyCode(); 
       
        int m=evt.getModifiers();  //masque modificateurs clavier
        if( t == KeyEvent.VK_DOWN )	{ onKeyDown(); 	}
        if( t == KeyEvent.VK_SPACE ){ onKeySpace(); }
        if( t == KeyEvent.VK_UP ) 	{ onKeyUp(); 	}
        if( t == KeyEvent.VK_LEFT )	{ onKeyLeft(); 	}
        if( t == KeyEvent.VK_RIGHT ){ onKeyRight();	}
    }
    
    /**
     * @see tetris.TetrisGraphics#AfficheInfos(int, int, int)
     */
    public void AfficheInfos(int score, int niveau, int prochainePiece) {
        m_TetrisInfos.AfficheInfos( score, niveau, prochainePiece );
    }
    /**
     * @see tetris.TetrisGraphics#AfficheMorceauPiece(int, int, int)
     */
    public void AfficheMorceauPiece(int ligne, int colonne, int couleur) {
        m_TetrisPlay.AfficheMorceauPiece( ligne, colonne, couleur );
    }
    /**
     * @see tetris.TetrisGraphics#AfficheTetris()
     */
    public void AfficheTetris() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisPlay.repaint();
        }
    }
    /**
     * @see tetris.TetrisEvents#onKeyLeft()
     */
    public void onKeyLeft() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisCore.Gauche();
        }        
    }
    /**
     * @see tetris.TetrisEvents#onKeyRight()
     */
    public void onKeyRight() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisCore.Droite();
        }        
    }
    /**
     * @see tetris.TetrisEvents#onKeyUp()
     */
    public void onKeyUp() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisCore.Tourne();
        }        
    }
    /**
     * @see tetris.TetrisEvents#onKeyDown()
     */
    public void onKeyDown() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisCore.Descend();
        }        
    }
    /**
     * @see tetris.TetrisEvents#onKeySpace()
     */
    public void onKeySpace() {
        if( m_Jeu && ! m_Pause )
        {
            m_TetrisCore.Tombe();
        }        
    }    
    /**
     * @see tetris.ApplicationEvents#onApplicationExit()
     */
    public void onApplicationExit() {
        System.exit(0);        
    }
    
    /**
     * @see tetris.ApplicationEvents#onButtonPlay()
     */
    public void onButtonPlay() {
        m_Jeu = true; m_Perdu = false;
        m_TetrisCore = new TetrisCore( this);
        m_TetrisPlay.setTetrisCore( m_TetrisCore );
        m_TetrisPlay.repaint();
        m_TetrisInfos.setTetrisCore( m_TetrisCore );
        m_TetrisInfos.repaint();
        m_TetrisThread = new Thread( this);
        m_TetrisThread.start();            
    }
    /**
     * @see tetris.ApplicationEvents#onButtonPause()
     */
    public void onButtonPause() {
        m_Pause = ! m_Pause;
	}
    /**
     * @see tetris.ApplicationEvents#onButtonShowScores()
     */
    public void onButtonShowScores() {        
        /*TetrisShowScores tss;
        tss = new TetrisShowScores( m_ctn);
        tss.show();*/        
    }
    /**
     * @see tetris.ApplicationEvents#onButtonAddScores()
     */
    public void onButtonAddScores() {
        /*TetrisAddScore tas;
        tas = new TetrisAddScore( this, m_TetrisCore.getScore());
        tas.show();*/
        m_TetrisInfos.addScore( m_TetrisCore.getScore(), m_saveScore );        
    }
    /**
     * @see tetris.ApplicationEvents#onButtonAPropos()
     */
    public void onButtonAPropos() {
        /*TetrisAPropos ta;
        Frame f = new Frame("");
        f.show();
        ta = new TetrisAPropos( f);
        ta.show();*/
    }
}

/** Ce panel affiche le "terrain de jeu" de tetris
 * 
 * @author sylvain
 *
 */
class TetrisPlay extends Panel
{
    private static final int ms_xOrg = 4; 
    private static final int ms_yOrg = 4; 
    private static final int ms_xCol = 10;
    private static final int ms_yLig = 20;
    
    private int m_xMorceau;
    private int m_yMorceau;
    private TetrisCore m_TetrisCore = null;
    TetrisPlay()
    {
    	setBackground( Color.black );
    }
    
    
    /**
     * @return Returns the tetrisCore.
     */
    public TetrisCore getTetrisCore() {
        return m_TetrisCore;
    }
    /**
     * @param tetrisCore The tetrisCore to set.
     */
    public void setTetrisCore(TetrisCore tetrisCore) {
        m_TetrisCore = tetrisCore;
    }
    
    /**
     * @param yLig
     * @param xCol
     * @param couleur
     */
    public void AfficheMorceauPiece( int yLig, int xCol, int couleur )
    {
        Color cr = TetrisValeur.TetrisValeur2Color( couleur );
        Graphics g = getGraphics();
        g.setColor( cr);        
        g.fillRect( ms_xOrg + (xCol )* ( m_xMorceau + 1), 
                ms_yOrg + (yLig ) * ( m_yMorceau + 1), 
                m_xMorceau, m_yMorceau);
    }    
    
    /**
     * @see java.awt.Container#paint(java.awt.Graphics)
     */
    public void paint( Graphics g)
    {
        Dimension r = getSize();
        m_xMorceau = (r.width-ms_xOrg-ms_yOrg-ms_xCol+1)/ms_xCol;
        m_yMorceau = (r.height-ms_xOrg-ms_yOrg-ms_yLig + 1)/ms_yLig;
        
        int xEnd = ms_xOrg + (ms_xCol )* ( m_xMorceau + 1);
        int yEnd = ms_yOrg + (ms_yLig ) * ( m_yMorceau + 1);

        g.setColor( Color.gray);
        g.fillRect( 0, 0, ms_xOrg, r.height);
        g.fillRect( 0, 0, r.width, ms_yOrg);
        g.fillRect( 0, yEnd, r.width, r.height - yEnd);
        g.fillRect( xEnd, 0, r.width - xEnd, r.height);
        for( int yLig = 0; yLig < ms_yLig; yLig ++ )
        {
            for( int xCol = 0; xCol < ms_xCol; xCol ++)
            {
                int couleur = TetrisValeur.TETRIS_RIEN;
                if( m_TetrisCore != null )
                {
                    couleur = m_TetrisCore.getCouleur(yLig, xCol);
                }
                AfficheMorceauPiece( yLig, xCol, couleur );
            }
        }
    }
}

/** Ce panel affiche l'apercu de la prochaine piece ainsi 
 * que le score et le niveau
 * 
 * @author sylvain
 *
 */ 
class TetrisInfos extends Panel
{
    private TetrisApercu m_TetrisApercu = null;
    private TetrisCore m_TetrisCore = null;
    private TetrisAddScore2 m_TetrisAddScore2 = null;
    Label m_lblScore;
    Label m_lblNiveau;
    
    /** Constructeur
     * 
     *
     */
    public TetrisInfos()
    {
        m_TetrisApercu = new TetrisApercu(); 
        setLayout(new GridLayout(3, 1));
        Panel p = new Panel();
        p.setLayout( new BorderLayout(40, 20));
        p.add(new Panel(), BorderLayout.NORTH);
        p.add(new Panel(), BorderLayout.SOUTH);
        p.add(new Panel(), BorderLayout.EAST);
        p.add(new Panel(), BorderLayout.WEST);
        p.add(m_TetrisApercu, BorderLayout.CENTER);
        add( p);
        Panel pInter = new Panel();
        pInter.setLayout(new GridLayout(5, 1));
        m_lblScore = new Label();
        m_lblNiveau = new Label();
        pInter.add( "Center", m_lblScore );
        pInter.add( "Center", m_lblNiveau );
        add( pInter );
        m_TetrisAddScore2 = new TetrisAddScore2();
        add( m_TetrisAddScore2);
    }
    
    /**
     * @param score
     * @param saveScore
     */
    public void addScore( int score, SaveScore saveScore )
    {
        m_TetrisAddScore2.addScore(score, saveScore);
    }
    
    /**
     * @param score
     * @param niveau
     * @param prochainePiece
     */
    public void AfficheInfos( int score, int niveau, int prochainePiece) 
    {
        m_lblScore.setText( "Score : " + score );
        m_lblNiveau.setText( "Niveau " + niveau );
        if( m_TetrisApercu != null )
        {
            m_TetrisApercu.AfficheApercu( prochainePiece);
        }
    }

    /**
     * @return Returns the tetrisCore.
     */
    public TetrisCore getTetrisCore() {
        return m_TetrisCore;
    }

    /**
     * @param tetrisCore The tetrisCore to set.
     */
    public void setTetrisCore(TetrisCore tetrisCore) {
        m_TetrisCore = tetrisCore;
        m_TetrisApercu.setTetrisCore(tetrisCore);
    }
}

/** Ce panel affiche l'apercu de la prochaine piece 
 * 
 * @author sylvain
 *
 */
class TetrisApercu extends Panel
{
    private static final int ms_xOrg = 4; 
    private static final int ms_yOrg = 4; 
    private static final int ms_xCol = 5;
    private static final int ms_yLig = 6;    
    
    private int m_tabApercu[][] = new int [ms_yLig][ms_xCol];
    private int m_xMorceau;
    private int m_yMorceau;

    private TetrisCore m_TetrisCore = null;

    TetrisApercu()
    {
    	setBackground( Color.black );
    }
    
    private void initTabApercu( int couleur)
    {
        for( int lig = 0; lig < ms_yLig; lig ++ )
            for( int col = 0; col < ms_xCol; col ++ )
                m_tabApercu[lig][col] = TetrisValeur.TETRIS_RIEN;
        switch( couleur)
        {
        	case TetrisValeur.CARRE_BLEU: 
        	    m_tabApercu[2][1] = couleur; 
        	    m_tabApercu[3][1] = couleur; 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[3][2] = couleur; 
        	    break;
        	case TetrisValeur.LIGNE_ROUGE: 
        	    m_tabApercu[1][2] = couleur; 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[3][2] = couleur; 
        	    m_tabApercu[4][2] = couleur; 
        	    break;
        	case TetrisValeur.TRIANGLE_VERT: 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[3][1] = couleur; 
        	    m_tabApercu[3][2] = couleur; 
        	    m_tabApercu[3][3] = couleur; 
        	    break;
        	case TetrisValeur.ZIG1_CYAN: 
        	    m_tabApercu[2][1] = couleur; 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[3][2] = couleur; 
        	    m_tabApercu[3][3] = couleur; 
        	    break;
            case TetrisValeur.ZIG2_GRIS: 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[2][3] = couleur; 
        	    m_tabApercu[3][1] = couleur; 
        	    m_tabApercu[3][2] = couleur; 
                break;
            case TetrisValeur.L1_ROSE: 
        	    m_tabApercu[2][1] = couleur; 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[2][3] = couleur; 
        	    m_tabApercu[3][3] = couleur; 
                break;
            case TetrisValeur.L2_JAUNE: 
        	    m_tabApercu[2][1] = couleur; 
        	    m_tabApercu[2][2] = couleur; 
        	    m_tabApercu[2][3] = couleur; 
        	    m_tabApercu[3][1] = couleur; 
                break;
            default: 
                break;
        }

    }

    /**
     * @param prochainePiece la prchaine piece
     */
    public void AfficheApercu(int prochainePiece) 
    {
        Graphics g = getGraphics();
        initTabApercu( prochainePiece );
        for( int yLig = 0; yLig < ms_yLig; yLig ++ )
            for( int xCol = 0; xCol < ms_xCol; xCol ++ )
            {
                Color cr = TetrisValeur.TetrisValeur2Color( m_tabApercu[yLig][xCol] );
                g.setColor( cr);        
                g.fillRect( ms_xOrg + (xCol )* ( m_xMorceau + 1), 
                        ms_yOrg + (yLig ) * ( m_yMorceau + 1), 
                        m_xMorceau, m_yMorceau);
            }
    }
    /**
     * @return Returns the tetrisCore.
     */
    public TetrisCore getTetrisCore() {
        return m_TetrisCore;
    }

    /**
     * @param tetrisCore The tetrisCore to set.
     */
    public void setTetrisCore(TetrisCore tetrisCore) {
        m_TetrisCore = tetrisCore;
    }
    
    /**
     * @see java.awt.Container#paint(java.awt.Graphics)
     */
    public void paint( Graphics g)
    {
        Dimension r = getSize();
        m_xMorceau = (r.width-ms_xOrg-ms_yOrg-ms_xCol+1)/ms_xCol;
        m_yMorceau = (r.height-ms_xOrg-ms_yOrg-ms_yLig + 1)/ms_yLig;
        
        int xEnd = ms_xOrg + (ms_xCol )* ( m_xMorceau + 1);
        int yEnd = ms_yOrg + (ms_yLig ) * ( m_yMorceau + 1);


        g.setColor( Color.gray);
        g.fillRect( 0, 0, ms_xOrg, r.height);
        g.fillRect( 0, 0, r.width, ms_yOrg);
        g.fillRect( 0, yEnd, r.width, r.height - yEnd);
        g.fillRect( xEnd, 0, r.width - xEnd, r.height);

        
        int prochainePiece = m_TetrisCore != null ? 
                m_TetrisCore.getProchainePiece() : TetrisValeur.TETRIS_RIEN;
        
        AfficheApercu( prochainePiece);
    }
    
}

/** Ce panel permet la saisie du score et l'envoi via une connexion
 * HTTP sur le serveur
 * 
 * @author sylvain
 *
 */
class TetrisAddScore2 extends Panel implements ActionListener
{
    private TextField m_txtName;
    private Label m_lblScore;
    private Button m_bOK;
    private SaveScore m_saveScore;
    private int m_score;

    /** COnstructeur
     * 
     */
    public TetrisAddScore2() {
        setBackground(Color.lightGray);

        setLayout( new BorderLayout() );
        Panel panel = new Panel ();
        panel.setLayout( new GridLayout(2,2));
        panel.add( new Label("Votre nom :"));
        m_txtName = new TextField();
        panel.add( m_txtName );
        panel.add( new Label("Score :"));
        m_lblScore = new Label(); 
        panel.add( m_lblScore  );
        add ("North", panel);
        
        m_bOK = new Button( "Mettre  jour le score" );
        add( "South", m_bOK );
        m_bOK.addActionListener(this);
        setVisible(false);
     }
     /**
     * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
      */
     public void actionPerformed(ActionEvent evt) {
         Object source = evt.getSource();
         if( source == m_bOK )
         {
             String text = m_txtName.getText();
             m_saveScore.save( m_score, text );
             setVisible(false);
         }        
     }

    /** Permet a l'uilisateur de rentrer son nom
     * @param score
     * @param saveScore
     */
    public void addScore( int score, SaveScore saveScore )
    {
        m_saveScore = saveScore;
        m_score = score;
        m_txtName.requestFocus();
        m_lblScore.setText( "" + score );
        setVisible(true);
    }
}