/*
 * Created on 15 juin 2005
 * Le coeur de tetris
 * 
 */
package tetris;

import java.util.Random;

/**
 * @author sylvain
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class TetrisCore implements TetrisGraphics {


    // Declaration des pieces : 
    // ------------------------
	// On utilise  cet effet un tableau  4 dimensions
	// -Le premier indice correspond au type de piece
	// -Le 2 indice correspond  la rotation en cours
	// -Le 3 et 4 indices correspondent aux coordonnees 
	//  relatives de chaque element composant une piece
	//  Ces coordonnees sont dans un format {ligne, colonne}
    //
	// On remarque par ailleurs que l'ordre des elements
	// du tableau correspond  l'ordre de l'enumeration
	// TetrisValeur, cad CARRE, puis LIGNE, puis TRIANGLE etc.
    //
    static private final int cs_aPieces[/*7*/][/*4*/][/*4*/][/*2*/] =
    {
        {	// Le carre (toujours ds la meme position)
    	{
    		{0,0}, {0,1},
    		{1,0}, {1,1}
    	},
    	{
    		{0,0}, {0,1},
    		{1,0}, {1,1} 
    	},
    	{
    		{0,0}, {0,1},
    		{1,0}, {1,1} 
    	},
    	{
    		{0,0}, {0,1},
    		{1,0}, {1,1} 
    	}
        },

        {	// La ligne
    	{
    		{0,-1},{0,0},{0,1},{0,2}
    	},
    	{
    		{-1,0},
    		{0,0},
    		{1,0},
    		{2,0}
    	},
    	{
    		{0,-1},{0,0},{0,1},{0,2}
    	},
    	{
    		{-1,0},
    		{0,0},
    		{1,0},
    		{2,0}
    	}
        },

        {	// Le triangle
    	{
    		    {-1,0},
    	    {0,-1}, {0,0}, {0,1} 
    	},
    	{
    		    {-1,0},
    		    {0,0}, {0,1},
    		    {1,0}
    	},
    	{
    	    {0,-1}, {0,0}, {0,1},
    		    {1,0},
    	},
    	{
    		    {-1,0},
    	    {0,-1}, {0,0},
    		    {1,0}
    	}
        },

        {	// Le zigzag 1
    	{
    	    {0,-1}, {0,0},
    		    {1,0}, {1,1} 
    	},
    	{
    		    {-1,0},
    	    {0,-1}, {0,0} ,
    	    {1,-1}
    	},
    	{
    	    {0,-1}, {0,0},
    		    {1,0}, {1,1} 
    	},
    	{
    		    {-1,0},
    	    {0,-1}, {0,0} ,
    	    {1,-1}
    	}
        },

        {	// Le zigzag 2
    	{
    		    {0,0}, {0,1},
    	    {1,-1}, {1,0} 
    	},
    	{
    	    {-1,-1},
    	    {0,-1}, {0,0}, 
    		    {1,0} 
    	},
    	{
    		    {0,0}, {0,1},
    	    {1,-1}, {1,0} 
    	},
    	{
    	    {-1,-1},
    	    {0,-1}, {0,0}, 
    		    {1,0} 
    	}
        },
        
        {	// Le L 1
    	{
    	    {0,-1}, {0,0},   {0,1},
    			    {1,1} 
    	},
    	{
    		    {-1,0},
    		    {0,0},
    	    {1,-1}, {1,0}
    	},
    	{
    	    {-1,-1},
    	    {0,-1}, {0,0},   {0,1},
    	},
    	{
    		    {-1,0}, {-1,1},
    		    {0,0},
    		    {1,0}
    	}
        },

        {	// Le L 2
    	{
    	    {0,-1}, {0,0}, {0,1},
    	    {1,-1} 
    	},
    	{
    	    {-1,-1},{-1,0},
    		    {0,0},
    		    {1,0}
    	},
    	{
    			   {-1,1},
    	    {0,-1}, {0,0}, {0,1},
    	},
    	{
    		    {-1,0},
    		    {0,0},
    		    {1,0}, {1,1}
    	}
        }
    };
    
    /** Dimension du tableau
     * 
     */
    public static final int TETRIS_COLONNES = 10;
    
    /** Dimension du tableau
     * 
     */
    public static final int TETRIS_LIGNES = 20;
    private int cs_Colonnes = TETRIS_COLONNES;

    private int cs_Lignes = TETRIS_LIGNES;


    // Declaration du tableau
    private int m_aTetris[][] = 
        new int[cs_Lignes][cs_Colonnes];
    private int m_colTetris;

	// Delai entre 2 mouvements : Ce delai va diminuer en meme
	// temps que le niveau du jeu augmente
    private int m_Delai;
    private boolean m_fAfficheProchainePiece = true;

	// Definit la position de la piece dans le tableau
    private int m_ligTetris;
    private int m_Niveau;

	// Definit la piece qui est actuellement affichee et
	// en cours de descente
    private int m_PieceCourante;

    // Voir ChoisirPiece() 
    private boolean m_PremierChoix = true;

	// Definit la prochaine piece qui va s'afficher. Celle
	// ci est utilisee afin de la montrer  l'utilisateur
	// dans un coin de l'ecran
	// Par defaut, on active l'apercu
    private int m_ProchainePiece;

	// Definit la rotation en cours
    private int m_Rotation;

    // Score et niveau
    private int m_Score;
    
    private TetrisGraphics m_TetrisGraphics;
    
    /**
     * @see tetris.TetrisGraphics#AfficheInfos(int, int, int)
     */
    public void AfficheInfos(int score, int niveau, int prochainePiece) {
        // TODO Auto-generated method stub
        m_TetrisGraphics.AfficheInfos( score, niveau, prochainePiece);
    }

    /**
     * @see tetris.TetrisGraphics#AfficheMorceauPiece(int, int, int)
     */
    public void AfficheMorceauPiece(int ligne, int colonne, int couleur) {
        // TODO Auto-generated method stub
        m_TetrisGraphics.AfficheMorceauPiece(ligne, colonne, couleur);
    }

    /**
     * Affiche la piece  la position indiquee par les variables
     * m_Rotation, m_ligTetris et m_colTetris.
	 * Appelle la fonction AfficheMorceauPiece() du module d'affichage
	 * qui realise l'affichage.
	 * On note que si la valeur de couleur est TETRIS_RIEN, alors la piece est
	 * effacee
     * @param couleur type de piece
     * 
     */
    private void AffichePiece( int couleur )
    {
        for( int morceau = 0; morceau < 4; morceau ++ )
        {
	    	int ligneRel = 
	    	    cs_aPieces[m_PieceCourante][m_Rotation%4][morceau][0];
	    	int colonneRel = 
	    	    cs_aPieces[m_PieceCourante][m_Rotation%4][morceau][1];
	
	    	int ligne = m_ligTetris + ligneRel;
	    	int colonne = m_colTetris + colonneRel;
	
	    	if( ligne >= 0 && ligne < cs_Lignes &&
	    	    colonne >= 0 && colonne < cs_Colonnes )
	    	{
	    	    // On change la couleur de cette cellule
	    	    m_aTetris[ligne][colonne] = couleur;
	    	    
	    	    // On appelle la fonction qui est chargee d'afficher la cellule
	    	    AfficheMorceauPiece( ligne, colonne, couleur );
	    	}
        }
    }

    /**
     * @see tetris.TetrisGraphics#AfficheTetris()
     */
    public void AfficheTetris() {
        // TODO Auto-generated method stub
        m_TetrisGraphics.AfficheTetris();
    }

    
    /** Modifie le score et le niveau en fonction du nombre de lignes
     * realisees. Agit sur les variables
     * 
     * @param nombreNouvellesLignes
     * 
     */
    private void ChangeScoreEtNiveau( int nombreNouvellesLignes )
    {
        m_Score += nombreNouvellesLignes;
        if( m_Score > 100 )
        {
	    	m_Niveau = 7;
	    	m_Delai = 100;
        }
        else if( m_Score > 70 )
        {
	    	m_Niveau = 6;
	    	m_Delai = 200;
        }
        else if( m_Score > 50 )
        {
	    	m_Niveau = 5;
	    	m_Delai = 300;
        }
        else if( m_Score > 40 )
        {
	    	m_Niveau = 4;
	    	m_Delai = 400;
        }
        else if( m_Score > 30 )
        {
	    	m_Niveau = 3;
	    	m_Delai = 500;
        }
        else if( m_Score > 20 )
        {
	    	m_Niveau = 2;
	    	m_Delai = 600;
        }
        else if( m_Score > 10 )
        {
	    	m_Niveau = 1;
	    	m_Delai = 800;
        }
    }

    /**
     * Choisit la piece qui doit s'afficher ainsi que la prochaine
     * piece  venir en utilisant PieceAuHasard().
     * Initialise les variables :
	 * -m_PieceCourante
	 * -m_ProchainePiece
     * 
     */
    private void ChoisirPiece()
    {
        // Cette fonction est appelee au debut du jeu puis chaque fois qu'une
        // piece arrive en bas.
        // Elle initialise les variables m_ProchainePiece et m_PieceCourante.
        // Elle utilise PieceAuHasard()
        // 
        // La premiere fois (variable m_PremierChoix), 
        // cette fonction initialise les variables m_ProchainePiece et m_PieceCourante.
        // 
        // Les fois suivantes, elle initialise m_PieceCourante avec m_ProchainePiece, 
        // puis m_ProchainePiece au hasard.

        if( m_PremierChoix )
        {
	    	m_PieceCourante = PieceAuHasard();
	    	m_PremierChoix = false;
        }
        else
        {
	    	m_PieceCourante = m_ProchainePiece;
        }
        m_ProchainePiece = PieceAuHasard();
    }


    /** Decale les lignes du tableau d'index inferieur  iLigne.
     * Cette fonction est appelee lorsque des lignes sont completes
     * @param iLigne la ligne
     * 
     */
    private void DecaleTableau(int iLigne)
    {
        for( int i = iLigne; i > 0; i -- )
        {
	    	for( int j = 0; j < cs_Colonnes; j ++ )
	    	{
	    	    m_aTetris[i][j] = m_aTetris[i-1][j];
	    	}
        }
    }


    /**
	 * Descend la piece d'un cran. Si la piece ne peut pas descendre plus bas
	 * alors on selectionne une nouvelle piece qu'on essaye d'afficher.
	 * Si cela n'est pas possible, alors cela signifie que la partie est
	 * perdue.
 	 * Utilise la fonction GereMouvementPiece() qui fait tout le travail
 	 * 
     * @return Renvoie false si la partie est perdu, true sinon
     * 
     */
    public synchronized boolean Descend()
    {
        boolean ret;

        ret = GereMouvementPiece( 1, 0, 0 );
        if( ret == false )
        {
	    	PieceEnBas();
	    	NouvellePiece();
	    	AfficheInfos( getScore(), getNiveau(), getProchainePiece() );
	    	ret = GereMouvementPiece( 1, 0, 0 );;
        }
        return ret;
    }


	/** Essaye de se deplacer  droite
	 * 
	*/
    public synchronized void Droite()
    {
        GereMouvementPiece( 0, 1, 0 );
    }


    /** Essaye de se deplacer  gauche
     * 
     */
    public synchronized void Gauche()
    {
        GereMouvementPiece( 0, -1, 0 );
    }


    /** Essaie de deplacer la piece  une nouvelle position.
     * 
	 * si ligIncrement = 1 => On descend
	 * si colIncrement = 1, on va  droite
	 * si colIncrement = -1, on va  gauche
	 * si rotIncrement = 1, on tourne
	 * 
     * @param ligIncrement
     * @param colIncrement
     * @param rotIncrement
     * @return Renvoie true si le deplacement voulu a pu etre realise
     * 
     */
    private boolean GereMouvementPiece( int ligIncrement, int colIncrement, int rotIncrement )
    {
        boolean ret = false;

        // On commence par effacer
        AffichePiece( TetrisValeur.TETRIS_RIEN );
        
        // On teste si on peut bouger
        if( PiecePeutBouger( ligIncrement, colIncrement, rotIncrement ) )
        {
	    	// On change les variables
	    	PieceBouge( ligIncrement, colIncrement, rotIncrement );
	
	    	// On a bouge
	    	ret = true;
        }
        
        // On reaffiche
        AffichePiece( m_PieceCourante );

        return ret;
    }

    /**
     * @param ligne
     * @param colonne
     * @return Type de piece
     */
    public int getCouleur( int ligne, int colonne )
    {
        // Renvoie la couleur de la piece (m_aTetris[ligne][colonne])
        return m_aTetris[ligne][colonne];
    }

    /**
     * @return Returns the delai.
     */
    public int getDelai() {
        return m_Delai;
    }
    /**
     * @return Returns the niveau.
     */
    public int getNiveau() {
        return m_Niveau;
    }
    /**
     * @return Returns the pieceCourante.
     */
    public int getPieceCourante() {
        return m_PieceCourante;
    }
    /**
     * @return Returns the prochainePiece.
     */
    public int getProchainePiece() {
        if( m_fAfficheProchainePiece ) return m_ProchainePiece;
        return TetrisValeur.TETRIS_RIEN; 
    }
    /**
     * @return Returns the score.
     */
    public int getScore() {
        return m_Score;
    }


    /**
     * Verifie si la ligne iLigne est complete.
     * @param iLigne numero de ligne
     * @return true si la ligne est complete
     */
    private boolean LigneComplete( int iLigne )
    {
        for( int j = 0; j < cs_Colonnes; j ++ )
        {
	    	if( m_aTetris[iLigne][j] == TetrisValeur.TETRIS_RIEN )
	    	{
	    	    return false; // La ligne n'est pas complete
	    	}
        }        
        return true; // Ligne complete
    }



	/** Initialise les variables pour qu'une nouvelle partie puisse
	 * commencer
	 */
    public void NouvellePartie()
    {
        // Tableau initialise  TETRIS_RIEN
        for( int i = 0; i < cs_Lignes; i ++ )
        {
	    	for( int j = 0; j < cs_Colonnes; j ++ )
	    	{
	    	    m_aTetris[i][j] = TetrisValeur.TETRIS_RIEN;
	    	}
        }

        // Variables m_Delai initialisee  1000, m_Score  0
        // m_Niveau  0
        m_Delai = 1000;
        m_Score = 0;
        m_Niveau = 0;
    }


    /**
     * Selectionne la nouvelle piece  utiliser en appelant la fonction
     * ChoisirPiece().
	 * Reinitialise les variables de position
     * 
     */
    public void NouvellePiece()
    {
        // Appelle ChoisirPiece() afin d'initialiser m_PieceCourante et 
        // m_ProchainePiece
        // Reinitialise m_ligTetris  0, m_colTetris  cs_Colonnes/2 et 
        // m_Rotation  0 afin que la nouvelle piece s'affiche en haut 
        // et au milieu du tableau
        ChoisirPiece();
        m_ligTetris = 0;
        m_colTetris = cs_Colonnes/2;
        m_Rotation = 0;
    }

    /** Tire une piece au hasard
     * @return type de piece
     * 
     */
    private int PieceAuHasard()
    {
        Random r = new Random();
        int val = Math.abs(r.nextInt());
        return (val % TetrisValeur.TETRIS_RIEN);
    }


    /** Incremente les variables de position
     * @param ligIncrement
     * @param colIncrement
     * @param rotIncrement
     * 
     */
    private void PieceBouge( int ligIncrement, int colIncrement, int rotIncrement )
    {
        // Incremente m_Rotation, m_ligTetris et m_colTetris avec 
        // ligIncrement, colIncrement et rotIncrement
        m_Rotation += rotIncrement;
        m_ligTetris += ligIncrement;
        m_colTetris += colIncrement;
    }


    /**
	 * Verifie la presence de lignes completes et les efface le
	 * cas echeant puis decale toutes celles qui sont au dessus.
	 * Utilise les fonctions LigneComplete() et DecaleTableau().
	 * Si des decalages ont lieu, le tableau est redessine
	 * Appelle la fonction AfficheTetris() du module d'affichage
	 * qui realise l'affichage
	 * Le cas echeant, elle incremente le score en appelant
	 * la fonction ChangeScoreEtNiveau()
     * 
     */
    private void PieceEnBas()
    {
        int nombreNouvellesLignes = 0;
        for( int i = cs_Lignes-1; i >= 0; i -- )
        {
	    	if( LigneComplete(i) )
	    	{
	    	    DecaleTableau(i);
	    	    nombreNouvellesLignes ++;
	    	    i ++;
	    	}
        }
        if( nombreNouvellesLignes != 0 )
        {
	    	AfficheTetris();
	    	ChangeScoreEtNiveau( nombreNouvellesLignes );
        }
    }


    /** 
     * Renvoie 1 si la piece peut bouger dans une des direction indiquee par
	 * les arguments.
     * @param ligIncrement
     * @param colIncrement
     * @param rotIncrement
     * @return true si la piece peut bouger
     * 
     */
    private boolean PiecePeutBouger( int ligIncrement, int colIncrement, int rotIncrement )
    {
        // Pour chaque morceau composant la piece, on calcule la
        // prochaine position, ensuite on verifie que si cette
        // position est dans le tableau, elle est libre
        for( int morceau = 0; morceau < 4; morceau ++ )
        {
	    	// Calcul de la position
	    	// On tient compte de la rotation
	    	int ligneRel = cs_aPieces[m_PieceCourante][(m_Rotation+rotIncrement)%4][morceau][0];
	    	int colonneRel = cs_aPieces[m_PieceCourante][(m_Rotation+rotIncrement)%4][morceau][1];
	
	    	// On ajuste la position en fonction des translations (droite/gauche/bas)
	    	int ligne = m_ligTetris + ligneRel + ligIncrement;
	    	int colonne = m_colTetris + colonneRel + colIncrement;
	
	    	// Est-ce que cette position est dans le tableau ?
	    	if( ligne >= 0 && ligne < cs_Lignes &&
	    	    colonne >= 0 && colonne < cs_Colonnes )
	    	{
	    	    // On est dans le tableau
	    	    if( m_aTetris[ligne][colonne] != TetrisValeur.TETRIS_RIEN )
	    	    {
	    	        return false; // La cellule est occupee
	    	    }
	    	}
	    	else
	    	{
	    	    return false; // On est sur un bord
	    	}
        }

        // Cette position est libre
        return true;
    }
    
    /**
     * @param ap
     */
    public void setApercu( boolean ap )
    {
        m_fAfficheProchainePiece = ap;
    }
    /**
     * @param delai The delai to set.
     */
    public void setDelai(int delai) {
        m_Delai = delai;
    }
    
    /** Constructeur
     * @param tg
     *
     */
    public TetrisCore( TetrisGraphics tg )
    {
        m_TetrisGraphics = tg;
        NouvellePartie();
        NouvellePiece();
    }



    /**
	 * Descend la piece jusqu'en bas, puis selectionne une nouvelle piece.
     * Si on ne peut pas afficher la nouvelle piece, cela signifie que la
     * partie est perdue, et la fonction renvoie false.
     * Utilise la fonction GereMouvementPiece() qui fait tout le travail
     * @return Renvoie false si la partie est perdu, true sinon
     * 
     */
    public synchronized boolean Tombe()
    {
        boolean ret;

        while( GereMouvementPiece( 1, 0, 0 ) );
        
        PieceEnBas();
        NouvellePiece();
        AfficheInfos( getScore(), getNiveau(), getProchainePiece() );
        
        ret = GereMouvementPiece( 1, 0, 0 );;
        return ret;
    }


	/** Essaye de tourner.
	 * 
	 */
    public synchronized void Tourne()
    {
        GereMouvementPiece( 0, 0, 1 );
    }
    
    
    
    
}
