/*
 * Created on 15 juin 2005
 *
 *
 */
package tetris;
import java.awt.*;

/**
 * @author sylvain
 * Cette classe decrit les types de pieces et leur couleur
 *
 */
public class TetrisValeur {
    private int m_Valeur;
    
    /**
     * <code>CARRE_BLEU</code>
     */
    public static final int CARRE_BLEU = 0;
    /**
     * <code>LIGNE_ROUGE</code>
     */
    public static final int LIGNE_ROUGE = 1;
    /**
     * <code>TRIANGLE_VERT</code>
     */
    public static final int TRIANGLE_VERT = 2;
    /**
     * <code>ZIG1_CYAN</code>
     */
    public static final int ZIG1_CYAN = 3;
    /**
     * <code>ZIG2_GRIS</code>
     */
    public static final int ZIG2_GRIS = 4;
    /**
     * <code>L1_ROSE</code>
     */
    public static final int L1_ROSE = 5;
    /**
     * <code>L2_JAUNE</code>
     */
    public static final int L2_JAUNE = 6;
    /**
     * <code>TETRIS_RIEN</code>
     */
    public static final int TETRIS_RIEN = 7;
    
    
    /**
     * @return Returns the valeur.
     */
    public int getValeur() {
        return m_Valeur;
    }
    /**
     * @param valeur The valeur to set.
     */
    public void setValeur(int valeur) {
        m_Valeur = valeur;
    }
    
    /**
     * 
     */
    public TetrisValeur()
    {
        setValeur( TETRIS_RIEN );
    }
    
    /**
     * @param couleur
     * @return la couleur
     */
    static public Color TetrisValeur2Color( int couleur )
    {
        Color cr;
        switch( couleur)
        {
        	case CARRE_BLEU: cr = Color.blue; break;
        	case LIGNE_ROUGE: cr = Color.red; break;
        	case TRIANGLE_VERT: cr = Color.green; break;
        	case ZIG1_CYAN: cr = Color.cyan; break;
            case ZIG2_GRIS: cr = Color.gray; break;
            case L1_ROSE: cr = Color.pink; break;
            case L2_JAUNE: cr = Color.yellow; break;
            default: cr = Color.black; break;
        }
        return cr;
    }
}
